#include "header.h"
#pragma comment( lib, "user32.lib" )

#if DEBUG

void LogGUID(const GUID& riid)
{
	if      ( riid == IID_IUnknown                   ) LOG( "IID_IUnknown\r\n"                   );
	else if ( riid == IID_IClassFactory              ) LOG( "IID_IClassFactory\r\n"              );
	else if ( riid == IID_IDirectDraw                ) LOG( "IID_IDirectDraw\r\n"                );
	else if	( riid == IID_IDirectDraw2               ) LOG( "IID_IDirectDraw2\r\n"               );
	else if	( riid == IID_IDirectDraw4               ) LOG( "IID_IDirectDraw4\r\n"               );
	else if	( riid == IID_IDirectDraw7               ) LOG( "IID_IDirectDraw7\r\n"               );
	else if ( riid == IID_IDirectDrawSurface         ) LOG( "IID_IDirectDrawSurface\r\n"         );
	else if ( riid == IID_IDirectDrawSurface2        ) LOG( "IID_IDirectDrawSurface2\r\n"        ); 
	else if ( riid == IID_IDirectDrawSurface3        ) LOG( "IID_IDirectDrawSurface3\r\n"        );
	else if ( riid == IID_IDirectDrawSurface4        ) LOG( "IID_IDirectDrawSurface4\r\n"        );
	else if ( riid == IID_IDirectDrawSurface7        ) LOG( "IID_IDirectDrawSurface7\r\n"        );
	else if ( riid == IID_IDirectDrawClipper         ) LOG( "IID_IDirectDrawClipper\r\n"         );
	else if ( riid == IID_IDDVideoPortContainer      ) LOG( "IID_IDDVideoPortContainer\r\n"      );
	else if ( riid == IID_IDirectDrawVideoPort       ) LOG( "IID_IDirectDrawVideoPort\r\n"       );
	else if ( riid == IID_IDirectDrawVideoPortNotify ) LOG( "IID_IDirectDrawVideoPortNotify\r\n" );
	else 
	{
		LOG( ">>>> Unknown GUID: 0x%08X,0x%04X,0x%04X,0x%02X,0x%02X,0x%02X,0x%02X,0x%02X,0x%02X,0x%02X,0x%02X <<<<\r\n",
			riid.Data1, riid.Data2, riid.Data3, riid.Data4[0], riid.Data4[1], riid.Data4[2], riid.Data4[3], riid.Data4[4],
			riid.Data4[5], riid.Data4[6], riid.Data4[7]
		);
	}
}

//todo: stop buffer overflows...
void __cdecl Log( char* fmt, ...){
	static char buf[1024];
	static HANDLE file = INVALID_HANDLE_VALUE; 
	static size_t pos = 0; 
	OVERLAPPED ol;
	int len;
	DWORD bytes_written;

	if( file == INVALID_HANDLE_VALUE )
	{
		file = CreateFile("ddwrapper.log", GENERIC_WRITE, 
			FILE_SHARE_READ | FILE_SHARE_WRITE, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, 0
		);
		if( file == INVALID_HANDLE_VALUE ) return;
	}

	va_list args;
    va_start(args,fmt);
    len = wvsprintf( buf, fmt, args );
	va_end(args);

	//todo: if( len < strlen( fmt ) ) return; 

	ol.Offset = pos;
	ol.OffsetHigh = 0; 
	ol.hEvent = NULL;
	
	if( WriteFile(file, buf, len, &bytes_written,  &ol) )
	{
		pos += bytes_written;
	} 
	else
	{
		// GetLastError();
	}
}

#endif